package org.ssssssss.magicboot.controller;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.xxl.job.core.context.XxlJobHelper;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import org.ssssssss.magicboot.fxapi.HttpClientResult;
import org.ssssssss.magicboot.fxapi.HttpClientUtils;
import org.ssssssss.magicboot.fxapi.XKTokenAccess;
import org.ssssssss.magicboot.fxapi.model.CrmFXApiParam;
import org.ssssssss.magicboot.zdyutils.FXHTTP;
import org.ssssssss.magicboot.zdyutils.GcjJson;
import org.ssssssss.magicboot.zdyutils.MagicApi;

import java.text.SimpleDateFormat;
import java.util.Arrays;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@RestController
@RequestMapping("/materialreqbillv2")
public class materialreqbillXTController {
    static Logger log = LoggerFactory.getLogger("materialreqbillv2");

    public static void main(String[] args) throws Exception {
            new materialreqbillXTController().getSynDataAdd();
            new materialreqbillXTController().materialreqbillSave();
    }

    public void getOperation()throws Exception{
        FXHTTP fxapi = new FXHTTP();
        String apiName = "shipping_application__c";
        String[] arr ={"option_awaiting_review__c","option_pending_submission__c","option_pending_cancellation__c","option_awaiting_re__c"};

        List<CrmFXApiParam> paramList = Arrays.asList(
                new CrmFXApiParam("ISN", "erp_id__c", ""),
                new CrmFXApiParam("IN", "erp_document_status__c", arr),
                new CrmFXApiParam("EQ", "sync_status__c", "option_sync_success__c")
        );
        JSONObject jsonject = fxapi.getSynNewDataObj(true, "发货申请", apiName, paramList);
        JSONArray array = jsonject.getJSONObject("data").getJSONArray("dataList");
        if(array.isEmpty()){
            return;
        }
        for (int i = 0; i < array.size(); i++) {
            JSONObject str = array.getJSONObject(i);
            String crmId = GcjJson.getNodeValue(str, "JSON._id") != null ? GcjJson.getNodeValue(str, "JSON._id").toString() : "";
            String status = GcjJson.getNodeValue(str, "JSON.erp_document_status__c") != null ? GcjJson.getNodeValue(str, "JSON.erp_document_status__c").toString() : "";
            if("option_pending_submission__c".equals(status)){
                new materialreqbillXTController().doOperation(crmId,"submit");
            } else if ("option_awaiting_review__c".equals(status)) {
                new materialreqbillXTController().doOperation(crmId,"audit");
            } else if ("option_pending_cancellation__c".equals(status)) {
                new materialreqbillXTController().doOperation(crmId,"unsubmit");
            } else if ("option_awaiting_re__c".equals(status)) {
                new materialreqbillXTController().doOperation(crmId,"unaudit");
            }
        }

    }

    public void getSynDataAdd() throws Exception {
        FXHTTP fxapi = new FXHTTP();
        XKTokenAccess xktonken = new XKTokenAccess();
        // 查询magic接口
        //获取时间戳
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        String time = sdf.format(System.currentTimeMillis() - (1000 * 60 * 60));

        String apiName = "shipping_application__c";

        List<CrmFXApiParam> paramList = Arrays.asList(
                new CrmFXApiParam("GT", "create_time", "1748923200000"),
                new CrmFXApiParam("GT", "last_modified_time", System.currentTimeMillis() - (1000 * 60 * 60 * 24)),
                new CrmFXApiParam("IS", "erp_id__c", ""),
                new CrmFXApiParam("EQ", "sync_status__c", "option_pending_sync__c"),
                new CrmFXApiParam("EQ", "life_status", "under_review")
        );

        //   List<CrmFXApiParam> paramList = Arrays.asList(new CrmFXApiParam("EQ", "name",  "FHSQ202505280014"));

        JSONObject jsonject = fxapi.getSynNewDataObj(true, "发货申请", apiName, paramList);
        JSONArray array = jsonject.getJSONObject("data").getJSONArray("dataList");

        List<CrmFXApiParam> paramListB = Arrays.asList(
                new CrmFXApiParam("EQ", "sync_status__c", "option_resync__c"),
                new CrmFXApiParam("EQ", "life_status", "normal")
        );
        JSONObject jsonjectB = fxapi.getSynNewDataObj(true, "发货申请重新同步", apiName, paramListB);
        JSONArray arrayA = jsonjectB.getJSONObject("data").getJSONArray("dataList");
        array.addAll(arrayA);


        for (int i = 0; i < array.size(); i++) {
            JSONObject str = array.getJSONObject(i);
            String dataId = GcjJson.getNodeValue(str,  "JSON._id") != null ? GcjJson.getNodeValue(str, "JSON._id").toString() : "";
            String nameData = GcjJson.getNodeValue(str, "JSON.name") != null ? GcjJson.getNodeValue(str, "JSON.name").toString() : "";
            String status = GcjJson.getNodeValue(str, "JSON.sync_status__c") != null ? GcjJson.getNodeValue(str, "JSON.sync_status__c").toString() : "";
            String endtime = GcjJson.getNodeValue(str, "JSON.last_modified_time") != null ? GcjJson.getNodeValue(str, "JSON.last_modified_time").toString() : "";

            String syn_type = "0";//同步类型 0新增 1修改 2删除
            log.info("-------------------开始执行发货申请" + i + " -------------------" + nameData);
            XxlJobHelper.log("-------------------开始执行发货申请" + i + " -------------------" + nameData);

            Boolean sendFlag = false;
            StringBuffer stringBuffer = new StringBuffer();

            try {
                boolean tbflag = false;
                //验证数据是否已存在
                JSONObject dataSyn = MagicApi.getSendSYNDatamaterialreqbill("FHD", syn_type, dataId);

                if (dataSyn != null && dataId.equals(dataSyn.getString("crmId"))) {
                    log.info("数据已存在-" + nameData);
                    XxlJobHelper.log("--数据已存在---" + nameData);
                    tbflag = true;
                    if("option_resync__c".equals(status) && !endtime.equals(dataSyn.getString("mark"))){
                        tbflag = false;
                    }
                }
                if (tbflag) {
                    continue;
                }
                log.info("发货申请待同步数据-" + i + " ------" + nameData);
                JSONObject jsonObjectData = new JSONObject();
                jsonObjectData.put("send_type", "FHD"); //业务类型
                jsonObjectData.put("send_syn", "0"); //同步类型 0新增 1修改 2删除
                jsonObjectData.put("crm_id", dataId);//数据id
                jsonObjectData.put("crmzhu_id", dataId);//数据id
                jsonObjectData.put("send_status", 3);//同步状态 true同步成功 false同步失败 3待同步
                jsonObjectData.put("crm_code", nameData);//数据名称
                jsonObjectData.put("mark", endtime);//标识
                jsonObjectData.put("crm_json", str.toJSONString());//标识

                MagicApi.saveSendSYNDatamaterialreqbill(jsonObjectData);
            } catch (Exception e) {
                continue;
            }

        }
    }

    public void materialreqbillSave() throws Exception {
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd hh:mm:ss");
        FXHTTP fxapi = new FXHTTP();
        String resJsonStr = MagicApi.getWNRES("http://localhost:18088/syn/querymaterialreqbill?sendType=FHD&sendStatus=3&sendSyn=0", "");
        JSONObject resJson = JSON.parseObject(resJsonStr);
        if (resJson != null) {
            log.info("待同步发货申请数" + resJson.getJSONArray("data").size());
            for (int i = 0; i < resJson.getJSONArray("data").size(); i++) {

                JSONObject getData = resJson.getJSONArray("data").getJSONObject(i);
                JSONObject str = getData.getJSONObject("crmJson");
                String syn_type = "0";//同步类型 0新增 1修改 2删除
                Boolean sendFlag = false;
                StringBuffer stringBuffer = new StringBuffer();
                boolean tbflag = false;
                // 构建json

                String dataId = GcjJson.getNodeValue(str, "JSON._id") != null ? GcjJson.getNodeValue(str, "JSON._id").toString() : "";
                String nameData = GcjJson.getNodeValue(str, "JSON.name") != null ? GcjJson.getNodeValue(str, "JSON.name").toString() : "";

                String sjerpid = GcjJson.getNodeValue(str, "JSON.design_file_ERPID__c") != null ? GcjJson.getNodeValue(str, "JSON.design_file_ERPID__c").toString() : "";
                String contractno = GcjJson.getNodeValue(str, "JSON.contract_number_text__c") != null ? GcjJson.getNodeValue(str, "JSON.contract_number_text__c").toString() : "";

                String contractno2 = GcjJson.getNodeValue(str, "JSON.pre_signed_contract_number__c") != null ? GcjJson.getNodeValue(str, "JSON.pre_signed_contract_number__c").toString() : "";


                String endtime = GcjJson.getNodeValue(str, "JSON.last_modified_time") != null ? GcjJson.getNodeValue(str, "JSON.last_modified_time").toString() : "";
                String status = GcjJson.getNodeValue(str, "JSON.sync_status__c") != null ? GcjJson.getNodeValue(str, "JSON.sync_status__c").toString() : "";

                String org1 = GcjJson.getNodeValue(str, "JSON.erp_organization_pre_contr__c__v") != null ? GcjJson.getNodeValue(str, "JSON.erp_organization_pre_contr__c__v").toString() : "";

                String org2 = GcjJson.getNodeValue(str, "JSON.erp_organization_sales_con__c__v") != null ? GcjJson.getNodeValue(str, "JSON.erp_organization_sales_con__c__v").toString() : "";

                String org = "";
                if(!"".equals(org2)){
                    org = org2;
                }else {
                    org = org1;
                }

                String cemployeeid = "";
                if (GcjJson.getNodeValue(str, "JSON.owner__r.id") != null) {
                    cemployeeid = GcjJson.getNodeValue(str, "JSON.owner__r.id").toString();
                    cemployeeid = fxapi.getDataBYID("PersonnelObj", "_id", cemployeeid, "JSON.data.dataList[0].field_T1xid__c");
                }

                String cdeptid = "";
                if (GcjJson.getNodeValue(str, "JSON.owner_department_id") != null) {
                    String dept_id = GcjJson.getNodeValue(str, "JSON.owner_department_id").toString();
                    cdeptid = fxapi.getDataBYID("DepartmentObj", "dept_id", dept_id, "JSON.data.dataList[0].field_Vj6sf__c");
                }
                String strJson = "";
                try{
                    JSONObject dataSyn = MagicApi.getSendSYNDatamaterialreqbill("FHD", syn_type, dataId,"3");
                    if (dataSyn != null && dataId.equals(dataSyn.getString("crmId"))) {
                        log.info("数据已存在-" + nameData);
                        XxlJobHelper.log("--数据已存在---" + nameData);
                        tbflag = true;
                        if("option_resync__c".equals(status) && !endtime.equals(dataSyn.getString("mark"))){
                            tbflag = false;
                        }
                    }
                    if (tbflag) {
                        continue;
                    }

                    JSONObject params = new JSONObject();

                    JSONArray dataarr = new JSONArray();
                    JSONObject datajson = new JSONObject();
                    datajson.put("billno",nameData);


                    datajson.put("org",org);
                    datajson.put("bizorg",org);
                    datajson.put("biztime",sdf.format(GcjJson.getNodeValue(str, "JSON.application_date__c")));
                    datajson.put("applyuser",cemployeeid);
                    datajson.put("applydept",cdeptid);
                    if(!"".equals(contractno2)){
                        datajson.put("contractno",contractno2);//contractno
                    }else {
                        datajson.put("contractno",contractno);//contractno
                    }


                    datajson.put("crmid",dataId);
                    datajson.put("erpId",sjerpid);//设计文件erpID //design_file_ERPID__c

                    //编号

                    //datajson.put("comment",remark);


                    JSONArray groupstandardarr = new JSONArray();

                    JSONObject jsonjectZ = fxapi.getZDYSynDataObj("发货申请明细", "shipping_product__c", "shipping_application__c", dataId);
                    JSONArray arrayZ = jsonjectZ.getJSONObject("data").getJSONArray("dataList");
                    for (int j = 0; j < arrayZ.size(); j++) {
                        JSONObject stra = arrayZ.getJSONObject(j);

                        JSONObject groupstandardjson = new JSONObject();

                        groupstandardjson.put("qty",GcjJson.getNodeValue(stra, "JSON.current_application_quanti__c"));
                        //产品编码
                        groupstandardjson.put("material",GcjJson.getNodeValue(stra, "JSON.material_name__c"));
                       // groupstandardjson.put("material","10060030170");
                        //仓库编码
                        groupstandardjson.put("warehouse",GcjJson.getNodeValue(stra, "JSON.warehouse_code__c"));
                        groupstandardjson.put("location",GcjJson.getNodeValue(stra, "JSON.warehouse_position__c"));

                        //批号
                        groupstandardjson.put("lot",GcjJson.getNodeValue(stra, "JSON.batch_number__c"));
                        groupstandardjson.put("ecostcenter",org);

                        //项目编码
                        groupstandardjson.put("project",GcjJson.getNodeValue(stra, "JSON.project_code__c"));

                        //设计文件明细ERPID
                        groupstandardjson.put("erpEntryId",GcjJson.getNodeValue(stra, "JSON.design_file_erp_detail_id__c"));
                       // groupstandardjson.put("erpEntryId","2216158993854770176");

                        groupstandardjson.put("crmentryid",GcjJson.getNodeValue(stra, "JSON._id"));

                        groupstandardjson.put("tracknumber",GcjJson.getNodeValue(stra, "JSON.shipping_tracking_number__c"));


                        groupstandardarr.add(groupstandardjson);

                    }

                    datajson.put("entryList",groupstandardarr);//明细
                   // dataarr.add(datajson);
                   // params.put("data",dataarr);
                    params=  datajson;
                    log.info("--请求json---" + params.toJSONString());
                    System.out.println("--请求json:---" +params.toJSONString());
                    System.out.println("::::"+params);
                    strJson = params.toJSONString();

                }catch  (Exception e) {
                    sendFlag = true;
                    stringBuffer.append("参数解析错误，请联系开发人员");
                    e.printStackTrace();
                }
                getSynDataSave(stringBuffer,sendFlag,fxapi,dataId,nameData,strJson,getData);

            }
        }
    }
    /**
     * 写数据
     */
    public void getSynDataSave(StringBuffer stringBuffer,Boolean sendFlag,FXHTTP fxapi,String dataId,String nameData,String obj,JSONObject str) {
        String syn_type = "0";//同步类型 0新增 1修改 2删除
        String res_url = "http://192.168.31.158:8022/ierp/kapi/v2/f9w5/im/materialreqbill/push";
        String res_param = obj;
        String res = "";
        try {
          //  String accessToken = "2095345516136108032_XQmekTd9H2mWOICLK86jt4bMzjP53Bm4KrspyFaPG790rSA6k3CdpwJ9fSx9RiBhK63rKELG7oIyLPdeNgpXu47zRh6Ndnud9jf009";
            String accessToken = new KDTokenController().getKDAccessTokenTest();


            Map<String, String> headers = new HashMap<String, String>();
            headers.put("accessToken",  accessToken);//放token
            HttpClientResult rtn = HttpClientUtils.doPostJson(res_url, headers, obj);
            String resStr =  rtn.getContent();
            JSONObject resjs = JSONObject.parseObject(resStr);
            res = resStr;
            if (resjs != null && resjs.getBoolean("status")) {
                System.out.println(resjs);
                JSONObject successdata  =  resjs.getJSONObject("data");
                //JSONArray result = successdata.getJSONArray("result");
                //JSONObject erpdata = (JSONObject) result.get(0);
                String erpid = successdata.getString("pkId");

                Map<String, Object> paramMap = new HashMap<String, Object>();
                paramMap.put("erp_id__c", erpid);//数据ID
                paramMap.put("sync_status__c", "option_sync_success__c");
                paramMap.put("sync_info__c", "同步成功");
                paramMap.put("erp_document_status__c", "submit");
                fxapi.lock(false, dataId, "shipping_application__c");
                //回写json
                fxapi.upSynZDYFieldParam("", "shipping_application__c", dataId, paramMap);
                //调用提交
                this.doOperation(dataId,"submit");

            }else{
                sendFlag=true;
                stringBuffer.append("发货申请创建接口调用失败:"+resjs.getString("message"));
                Map<String, Object> paramMap = new HashMap<String, Object>();
                paramMap.put("sync_status__c", "option_sync_failure__c");
                paramMap.put("sync_info__c", stringBuffer);
                paramMap.put("erp_document_status__c", "option_pending_action__c");
                fxapi.lock(false, dataId, "shipping_application__c");
                //回写json
                fxapi.upSynZDYFieldParam("", "shipping_application__c", dataId, paramMap);
                fxapi.lock(true, dataId, "shipping_application__c");
            }
        } catch (Exception e) {
            sendFlag = true;
            stringBuffer.append("发货申请创建接口调用失败,请检查网络配置");
            Map<String, Object> paramMap = new HashMap<String, Object>();
            paramMap.put("sync_status__c", "option_sync_failure__c");
            paramMap.put("sync_info__c", stringBuffer);
            paramMap.put("erp_document_status__c", "option_pending_action__c");
            fxapi.lock(false, dataId, "shipping_application__c");
            //回写json
            fxapi.upSynZDYFieldParam("", "shipping_application__c", dataId, paramMap);
            fxapi.lock(true, dataId, "shipping_application__c");
        }

        JSONObject sendData = new JSONObject();

        sendData.put("send_status", !sendFlag);//同步状态 true同步成功 false同步失败 3待同步

        sendData.put("send_id", str.getString("sendId")); //send_id
        MagicApi.updateSendSYUPDATEmaterialreqbill(sendData);

        JSONObject logData = new JSONObject();
        logData.put("log_type", "FHD"); //业务类型
        logData.put("log_status", !sendFlag);//同步状态 true同步成功 false同步失败 3待同步
        logData.put("syn_type", syn_type);//同步类型 0新增 1修改 2删除
        logData.put("data_id", dataId);//数据id
        logData.put("data_name", nameData);//数据名称
        logData.put("res_body", "同步成功");//返回值
        logData.put("res_url", res_url);//
        logData.put("res_param", res_param);//
        logData.put("res_res", res);//
        if (sendFlag) {
            logData.put("res_body", stringBuffer.toString());//返回值
        }
        //写入传输日志
        MagicApi.saveCustomermaterialreqbill(logData);
    }

    public void doOperation(String crmId,String operation) throws Exception {
        FXHTTP fxapi = new FXHTTP();
        //操作类型：submit：提交；audit：审核；撤销：unsubmit；删除:delete;反审核：unaudit
        String res_url = "http://192.168.31.158:8022/ierp/kapi/v2/f9w5/im/materialreqbill/doOperation";
        JSONObject datajson = new JSONObject();
        datajson.put("crmId",crmId);
        datajson.put("operation",operation);

        String obj = datajson.toJSONString();

        String accessToken = new KDTokenController().getKDAccessTokenTest();


        Map<String, String> headers = new HashMap<String, String>();
        headers.put("accessToken",  accessToken);//放token
        HttpClientResult rtn = HttpClientUtils.doPostJson(res_url, headers, obj);
        String resStr =  rtn.getContent();
        JSONObject resjs = JSONObject.parseObject(resStr);

        if (resjs != null && resjs.getBoolean("status")) {
            JSONObject successdata  =  resjs.getJSONObject("data");
            String crmid = successdata.getString("crmid");
            String erpid = successdata.getString("pkId");
            String billno = successdata.getString("billno");

            Map<String, Object> paramMap = new HashMap<String, Object>();
            paramMap.put("erp_document_status__c", operation);//数据ID
            paramMap.put("review_info__c", operation+"调用成功");
            fxapi.lock(false, crmId, "shipping_application__c");
            //回写json
            fxapi.upSynZDYFieldParam("", "shipping_application__c", crmId, paramMap);
            if("submit".equals(operation)){//审核成功，操作完锁定状态
                fxapi.lock(true, crmId, "shipping_application__c");
            }
        }else{
            //响应的消息
            String message  =  resjs.getString("message");
            Map<String, Object> paramMap = new HashMap<String, Object>();
            paramMap.put("erp_document_status__c", "option_pending_action__c");//数据ID
            paramMap.put("review_info__c", message);


            if("submit".equals(operation)){//审核失败，解锁更新状态
                fxapi.cancel( message,crmId, "shipping_application__c");//取消审批
                //回写json
                fxapi.upSynZDYFieldParam("", "shipping_application__c", crmId, paramMap);
            }else {
                //其他情况，先解锁，在更新
                fxapi.lock(false, crmId, "shipping_application__c");
                fxapi.upSynZDYFieldParam("", "shipping_application__c", crmId, paramMap);
            }


        }
    }

}
